<template>
  <div>
    <div class="analyze" v-if="run">
      <el-tabs>
        <el-tab-pane label="General">
          <h2>Run: {{ course && course.name }}</h2>
          <p>Total time: {{ run.totalTime | formatElapsed }}</p>
          <p>Checkins: {{ run.checkins.nodes.length }}</p>
          <p>Events: {{ events.length }}</p>
          <LayerControls />
        </el-tab-pane>
        <el-tab-pane label="Events">
          <el-table :data="events">
            <el-table-column label="Time" width="80">
              <template #default="{ row }">
                {{
                  (new Date(row.time) - new Date(run.startedAt)) | formatElapsed
                }}
              </template>
            </el-table-column>
            <el-table-column prop="type" label="Type" width="100" />
            <el-table-column label="Accuracy" width="180">
              <template #default="{ row }">
                {{ row.data && row.data.accuracy }}
              </template>
            </el-table-column>
          </el-table>
        </el-tab-pane>
      </el-tabs>
    </div>

    <client-only>
      <portal to="map">
        <Checkpoint
          v-for="cp in checkpoints"
          :key="cp.key"
          :value="cp"
          :visited="visited(cp)"
        />
        <MglGeojsonLayer
          ref="analyzeGeojsonLayer"
          source-id="analyze-source"
          :source="geojson"
          layer-id="analyze-layer"
          :layer="style"
        />
        <MglConfig :items="checkpoints" />
      </portal>
    </client-only>
  </div>
</template>
<script>
import { get } from "~/lib/utils";
import { mapState } from "vuex";
import FetchQuery from "~/lib/fetch-query";

import { Tabs, TabPane } from "element-ui";

import MglConfig from "~/components/mapping/MglConfig";
import Checkpoint from "~/components/mapping/Checkpoint";

export default {
  components: {
    MglConfig,
    Checkpoint,
    "el-tabs": Tabs,
    "el-tab-pane": TabPane,
    LayerControls: () =>
      import("~/components/mapping/LayerControls").then((m) => m.default || m),
  },
  data() {
    return {
      error: null,
      run: null,
      geojson: {
        type: "geojson",
        data: { type: "FeatureCollection", features: [] },
      },
    };
  },
  beforeDestroy() {
    // Not sure why this is necessary:
    this.$refs.analyzeGeojsonLayer.remove();
  },
  watch: {
    events: {
      immediate: true,
      handler() {
        this.geojson = {
          type: "geojson",
          data: {
            type: "Feature",
            properties: {},
            geometry: {
              type: "MultiPoint",
              coordinates: (this.events || []).map((e) => [e.lng, e.lat]),
            },
          },
        };
      },
    },
  },
  fetch: FetchQuery(
    `
    query($runId:UUID!) {
      run(id: $runId) {
        id startedAt endedAt totalTime {
          seconds
          minutes
          hours
          days
          months
          years
        }

        course {
          name
          checkpoints(orderBy: [NAME_ASC]) {
            nodes {
              id lat lng name description radius
            }
          }
        }

        checkins {
          nodes {
            id checkpointId
          }
        }

        events:runEvents(orderBy: [TIME_ASC]) {
          nodes {
            id time type lat lng data
          }
        }
      }
    }
  `,
    function () {
      return { runId: this.$route.params.id };
    }
  ),
  computed: {
    course() {
      return get(this.run, "course");
    },
    checkpoints() {
      return get(this.run, "course.checkpoints.nodes");
    },
    events() {
      return get(this.run, "events.nodes");
    },
    checkins() {
      return get(this.run, "checkins.nodes");
    },

    style() {
      return {
        type: "circle",
        source: "analyze-source",
        paint: {
          "circle-radius": 2.5,
          "circle-color": "blue",
          "circle-opacity": 0.4,
        },
      };
    },
  },
  methods: {
    visited(cp) {
      return (
        this.checkins && !!this.checkins.find((v) => v.checkpointId == cp.id)
      );
    },
  },
};
</script>
<style lang="scss" scoped>
@import "~assets/mixins";

.analyze {
  pointer-events: initial;
  background-color: $color-background;
  width: $grid * 15;
  max-width: 70vw;
  max-height: 80vh;
  overflow: auto;
}
</style>
